ghc-7.0.4: The GHC API

FunDeps

# Documentation

data FDEq Source

Constructors

FDEq |

Fields

fd_pos :: Int
fd_ty_left :: Type
fd_ty_right :: Type

data Equation Source

Constructors

FDEqn |

Fields

fd_qtvs :: TyVarSet
fd_eqs :: [FDEq]
fd_pred1 :: Pred_Loc
fd_pred2 :: Pred_Loc

pprEquation :: Equation -> SDoc Source

oclose :: [PredType] -> TyVarSet -> TyVarSet Source

improveFromInstEnv :: (InstEnv, InstEnv) -> Pred_Loc -> [Equation]Source

improveFromAnother :: Pred_Loc -> Pred_Loc -> [Equation]Source

checkInstCoverage :: Class -> [Type] -> Bool Source

checkFunDeps :: (InstEnv, InstEnv) -> Instance -> Maybe [Instance]Source

pprFundeps :: Outputable a => [FunDep a] -> SDoc Source